// Funge JIT compiler
// Copyright (c) 2004 Marek Materzok
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.

#ifndef __bflibinlinepass_hpp
#define __bflibinlinepass_hpp

#include <set>

#include <llvm/Pass.h>

class BflibInlinePass: public llvm::FunctionPass
{
	public:
		virtual bool doInitialization(llvm::Module &m);
		virtual bool runOnFunction(llvm::Function &m);
		virtual bool doFinalization(llvm::Module &m);
	
	private:
		std::set<llvm::Function *> inlinable;
};

#endif

