// Funge JIT compiler
// Copyright (c) 2004 Marek Materzok
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version.

#ifndef __bfliblowervectorpass_hpp
#define __bfliblowervectorpass_hpp

#include <llvm/Pass.h>

class BflibLowerVectorPass: public llvm::BasicBlockPass
{
	public:
		virtual bool doInitialization(llvm::Module &m);
		virtual bool runOnBasicBlock(llvm::BasicBlock &m);
		virtual bool doFinalization(llvm::Module &m);

	private:
		void lowerPushVector(llvm::CallInst *ci);
		void lowerPopVector(llvm::CallInst *ci);
};

#endif

